dofile_once( "data/scripts/lib/utilities.lua" )

local player = get_players()[1]
local playerX, playerY = EntityGetTransform(player)
local controlsComponent = EntityGetFirstComponent(player, "ControlsComponent")
local mouseX, mouseY = ComponentGetValue2(controlsComponent, "mMousePosition")

local ourEntity = GetUpdatedEntityID()
local projectile = EntityGetComponent(ourEntity, "ProjectileComponent")
local caster = ComponentGetValue2( projectile[1], "mWhoShot")

local bakuretsu_shoot_T = EntityGetClosestWithTag(playerX, playerY, "bakuretsu_t_tag")



if (IsPlayer(caster) == true) then 
	EntitySetTransform(bakuretsu_shoot_T, mouseX, mouseY)
else
	local enemyX, enemyY = EntityGetTransform(caster)
	local bakuretsu_shoot_enemy_T = EntityGetClosestWithTag(enemyX, enemyY, "bakuretsu_t_tag")
	local boomX, boomY, boomD = EntityGetTransform(bakuretsu_shoot_T)

	local math_sin = math.sin
	local math_cos = math.cos

	local function angle2Vec(startX, startY, angle, distance)
		return startX + math_cos(angle)*distance, startY + math_sin(angle)*distance
	end

	local x, y = enemyX, enemyY
	local angle = boomD 
	local distance = 200
	local newX, newY = angle2Vec(x, y, angle, distance)
	
	EntitySetTransform(bakuretsu_shoot_enemy_T, newX, newY)	
end