table.insert( actions,
{
	id          = "MEGUMIN_EXPLOSION",
	name 		= "EXPLOSION!",
	description = "Explosion is the most powerfull magic used by arch-wizards, but it can only be cast once a day. \n                                           This spell also causes Megumin to lose all her body strength for 15s!",
	sprite 		= "mods/megumin_e/files/actions/m_explosion.png",
	type 		= ACTION_TYPE_PROJECTILE,
	spawn_level                       = "1,4,5,6", -- MEGUMIN_EXPLOSION
	spawn_probability                 = "1,1,1,1", -- MEGUMIN_EXPLOSION
	price = 2000,
	mana = 500,
	max_uses = -1,
	action 		= function()
		dofile_once( "data/scripts/megumin_no_mana_frame.lua" )
		dofile_once( "data/scripts/lib/utilities.lua" )
		
		local caster = GetUpdatedEntityID()
		
		if (IsPlayer(caster) == true) then
			local currentTime = GameGetFrameNum()
			if currentTime >= NO_MANA_TIMER then
				add_projectile("mods/megumin_e/files/actions/m_explosion_target.xml")
				add_projectile("mods/megumin_e/files/actions/m_explosion.xml")
				c.fire_rate_wait = 600
				current_reload_time = 600
				NO_MANA_TIMER = currentTime + 39960
			else
				local T_countdown = math.floor((NO_MANA_TIMER - currentTime)/60)
				GamePrintImportant(T_countdown .. " Seconds", "Time left until the next explosion is ready.","mods/megumin_e/files/explosion_message.png")
				draw_actions( 1, true )
			end
		elseif (IsPlayer(caster) ~= true) then
			add_projectile("mods/megumin_e/files/actions/m_explosion_target.xml")
			add_projectile("mods/megumin_e/files/actions/m_explosion.xml")
			c.fire_rate_wait = 1200
			current_reload_time = 1200
		end	
	end,
} )