dofile("data/scripts/lib/utilities.lua")

local player = get_players()[1]
local invis_effect = GameGetGameEffect(player, "INVISIBILITY")
local is_invisible = ComponentGetValue2( invis_effect, "mInvisible")

local copy_hat_sprite = EntityGetFirstComponent(player, "SpriteComponent", "copy_hat_fix")
local copy_no_hat_sprite = EntityGetFirstComponent(player, "SpriteComponent", "copy_no_hat_fix")

local hat1_sprite = EntityGetFirstComponent(player, "SpriteComponent", "hat_fix1")
local hat2_sprite = EntityGetFirstComponent(player, "SpriteComponent", "hat_fix2")

local cape_top1_sprite = EntityGetFirstComponent(player, "SpriteComponent", "cape_top_fix1")
local cape_top2_sprite = EntityGetFirstComponent(player, "SpriteComponent", "cape_top_fix2")

local verlet_b1 = EntityGetWithName("bang1")
local sprite_A1 = EntityGetFirstComponent(verlet_b1, "SpriteComponent", "bang1_sprite_1")
local sprite_A2 = EntityGetFirstComponent(verlet_b1, "SpriteComponent", "bang1_sprite_2")

local verlet_b2 = EntityGetWithName("bang2")
local sprite_B1 = EntityGetFirstComponent(verlet_b2, "SpriteComponent", "bang2_sprite_1")
local sprite_B2 = EntityGetFirstComponent(verlet_b2, "SpriteComponent", "bang2_sprite_2")

local verlet_c = EntityGetWithName("bangC")
local sprite_C = EntityGetFirstComponent(verlet_c, "SpriteComponent", "bangC_sprite_1")

local verlet_l = EntityGetWithName("bangL")
local sprite_L = EntityGetFirstComponent(verlet_l, "SpriteComponent", "bangL_sprite_1")

local verlet_r = EntityGetWithName("bangR")
local sprite_R = EntityGetFirstComponent(verlet_r, "SpriteComponent", "bangR_sprite_1")


if is_invisible == nil then
	ComponentSetValue2(sprite_A1,"alpha", 1)
	ComponentSetValue2(sprite_A2,"alpha", 1)
	ComponentSetValue2(sprite_B1,"alpha", 1)
	ComponentSetValue2(sprite_B2,"alpha", 1)
	ComponentSetValue2(sprite_C,"alpha", 1)
	ComponentSetValue2(sprite_L,"alpha", 1)
	ComponentSetValue2(sprite_R,"alpha", 1)
elseif is_invisible ~= nil then
	if is_invisible == "0" then
		ComponentSetValue2(sprite_A1,"alpha", 1)
		ComponentSetValue2(sprite_A2,"alpha", 1)
		ComponentSetValue2(sprite_B1,"alpha", 1)
		ComponentSetValue2(sprite_B2,"alpha", 1)
		ComponentSetValue2(sprite_C,"alpha", 1)
		ComponentSetValue2(sprite_L,"alpha", 1)
		ComponentSetValue2(sprite_R,"alpha", 1)
	elseif is_invisible == "1" then
		ComponentSetValue2(sprite_A1,"alpha", 0.9)
		ComponentSetValue2(sprite_A2,"alpha", 0.9)
		ComponentSetValue2(sprite_B1,"alpha", 0.9)
		ComponentSetValue2(sprite_B2,"alpha", 0.9)
		ComponentSetValue2(sprite_C,"alpha", 0.9)
		ComponentSetValue2(sprite_L,"alpha", 0.9)
		ComponentSetValue2(sprite_R,"alpha", 0.9)
	end
end


if ModSettingGet("megumin.HAT_TOGGLE") == true then
	if is_invisible == nil then
		ComponentSetValue2(copy_hat_sprite,"alpha", 1)
	elseif is_invisible ~= nil then
		ComponentSetValue2(copy_hat_sprite,"alpha", 0)
	end
elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
	if is_invisible == nil then
		ComponentSetValue(copy_no_hat_sprite,"alpha", 1)
	elseif is_invisible ~= nil then
		ComponentSetValue(copy_no_hat_sprite,"alpha", 0)
	end
end

if is_invisible == nil then
	ComponentSetValue2(hat1_sprite,"alpha", 1)
	ComponentSetValue2(hat2_sprite,"alpha", 0)
elseif is_invisible ~= nil then
	if is_invisible == "0" then
		ComponentSetValue2(hat1_sprite,"alpha", 0)
		ComponentSetValue2(hat2_sprite,"alpha", 1)
	elseif is_invisible == "1" then
		ComponentSetValue2(hat1_sprite,"alpha", 0)
		ComponentSetValue2(hat2_sprite,"alpha", 0.9)
	end
end


if ModSettingGet("megumin.CAPE_TOGGLE") == true then
	if is_invisible == nil then
		ComponentSetValue2(cape_top1_sprite,"alpha", 1)
		ComponentSetValue2(cape_top2_sprite,"alpha", 0)
	elseif is_invisible ~= nil then
		if is_invisible == "0" then
			ComponentSetValue2(cape_top1_sprite,"alpha", 0)
			ComponentSetValue2(cape_top2_sprite,"alpha", 1)
		elseif is_invisible == "1" then
			ComponentSetValue2(cape_top1_sprite,"alpha", 0)
			ComponentSetValue2(cape_top2_sprite,"alpha", 0.7)
		end
	end
end