dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/megumin_no_mana_frame.lua" )

local player = get_players()[1]
local sprite_P = EntityGetFirstComponent(player, "SpriteComponent")
local sprite_PC1 = EntityGetFirstComponent(player, "SpriteComponent", "Megumin_Copy_Hat")
local sprite_PC2 = EntityGetFirstComponent(player, "SpriteComponent", "Megumin_Copy_no_Hat")
local sprite_P2 = EntityGetFirstComponent(player, "SpriteComponent", "Megumin_Hat")
local sprite_P2b = EntityGetFirstComponent(player, "SpriteComponent", "hat_fix2")
local sprite_P3 = EntityGetFirstComponent(player, "SpriteComponent", "Megumin_Cape_Top")
local sprite_P3b = EntityGetFirstComponent(player, "SpriteComponent", "cape_top_fix2")

local enabled_crown = EntityGetFirstComponent(player, "SpriteComponent", "player_hat2")
local enabled_amulet = EntityGetFirstComponent(player, "SpriteComponent", "player_amulet")
local enabled_gem = EntityGetFirstComponent(player, "SpriteComponent", "player_amulet_gem")

local bakuretsu_e = EntityGetWithName("bakuretsu")
local projectile = EntityGetFirstComponent(bakuretsu_e, "ProjectileComponent")
local caster = ComponentGetValue( projectile, "mWhoShot")
local currentFrame = GameGetFrameNum()

if (IsPlayer(caster) == true) and MEGUMIN_NO_MANA_FRAME == false then 
	no_mana_timer = GameGetFrameNum()
	MEGUMIN_NO_MANA_FRAME= true
end

if MEGUMIN_NO_MANA_FRAME == true then
	if currentFrame >= no_mana_timer + 200 and  currentFrame <= no_mana_timer + 249 then
		ComponentSetValue2(sprite_P,"rect_animation", "paralysis",0)
		ComponentSetValue2(sprite_P2,"rect_animation", "paralysis",0)
		ComponentSetValue2(sprite_P2b,"rect_animation", "paralysis",0)
		if enabled_crown ~= nil then
			ComponentSetValue2(enabled_crown,"rect_animation", "paralysis",0)
		end
		if enabled_amulet ~= nil then
			ComponentSetValue2(enabled_amulet,"rect_animation", "paralysis",0)
		end
		if enabled_gem ~= nil then
			ComponentSetValue2(enabled_gem,"rect_animation", "paralysis",0)
		end
		if ModSettingGet("megumin.HAT_TOGGLE") == true then
			ComponentSetValue2(sprite_PC1,"rect_animation", "paralysis",0)
		elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
			ComponentSetValue2(sprite_PC2,"rect_animation", "paralysis",0)
		end
		if ModSettingGet("megumin.CAPE_TOGGLE") == true then
			ComponentSetValue2(sprite_P3,"rect_animation", "paralysis",0)
			ComponentSetValue2(sprite_P3b,"rect_animation", "paralysis",0)
		end
		LoadGameEffectEntityTo(player, "data/entities/misc/effect_megumin.xml")
	elseif currentFrame >= no_mana_timer + 250 and  currentFrame <= no_mana_timer + 919 then
		ComponentSetValue2(sprite_P,"rect_animation", "intro_sleep",0)
		ComponentSetValue2(sprite_P2,"rect_animation", "intro_sleep",0)
		ComponentSetValue2(sprite_P2b,"rect_animation", "intro_sleep",0)
		if enabled_crown ~= nil then
			ComponentSetValue2(enabled_crown,"rect_animation", "intro_sleep",0)
		end
		if enabled_amulet ~= nil then
			ComponentSetValue2(enabled_amulet,"rect_animation", "intro_sleep",0)
		end
		if enabled_gem ~= nil then
			ComponentSetValue2(enabled_gem,"rect_animation", "intro_sleep",0)
		end
		if ModSettingGet("megumin.HAT_TOGGLE") == true then
			ComponentSetValue2(sprite_PC1,"rect_animation", "intro_sleep",0)
		elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
			ComponentSetValue2(sprite_PC2,"rect_animation", "intro_sleep",0)
		end
		if ModSettingGet("megumin.CAPE_TOGGLE") == true then
			ComponentSetValue2(sprite_P3,"rect_animation", "intro_sleep",0)
			ComponentSetValue2(sprite_P3b,"rect_animation", "intro_sleep",0)
		end
	elseif currentFrame >= no_mana_timer + 920 and  currentFrame <= no_mana_timer + 1099 then
		ComponentSetValue2(sprite_P,"rect_animation", "intro_stand_up",0)
		ComponentSetValue2(sprite_P2,"rect_animation", "intro_stand_up",0)
		ComponentSetValue2(sprite_P2b,"rect_animation", "intro_stand_up",0)
		if enabled_crown ~= nil then
			ComponentSetValue2(enabled_crown,"rect_animation", "intro_stand_up",0)
		end
		if enabled_amulet ~= nil then
			ComponentSetValue2(enabled_amulet,"rect_animation", "intro_stand_up",0)
		end
		if enabled_gem ~= nil then
			ComponentSetValue2(enabled_gem,"rect_animation", "intro_stand_up",0)
		end
		if ModSettingGet("megumin.HAT_TOGGLE") == true then
			ComponentSetValue2(sprite_PC1,"rect_animation", "intro_stand_up",0)
		elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
			ComponentSetValue2(sprite_PC2,"rect_animation", "intro_stand_up",0)
		end
		if ModSettingGet("megumin.CAPE_TOGGLE") == true then
			ComponentSetValue2(sprite_P3,"rect_animation", "intro_stand_up",0)
			ComponentSetValue2(sprite_P3b,"rect_animation", "intro_stand_up",0)
		end
	elseif currentFrame == no_mana_timer + 1100 then
		MEGUMIN_NO_MANA_FRAME= false
	end	
end

--SHROOM STUFF
local old_shroom = EntityGetFirstComponent(player, "SpriteComponent", "player_hat")

if old_shroom ~= nil and SHROOMED ~= true then
	if ModSettingGet("megumin.SHROOM_TOGGLE") == "1" then
		ComponentSetValue2( sprite_P, "image_file", "mods/megumin/files/skin/enemies_gfx/player_shroom.xml" )
		ComponentSetValue2(sprite_P2, "image_file", "mods/megumin/files/skin/enemies_gfx/player_blank.xml")
		ComponentSetValue2(sprite_P2b, "image_file", "mods/megumin/files/skin/enemies_gfx/player_blank.xml")
		if ModSettingGet("megumin.HAT_TOGGLE") == true then
			ComponentSetValue2(sprite_PC1, "image_file", "mods/megumin/files/skin/enemies_gfx/player_blank.xml")
		elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
			ComponentSetValue2(sprite_PC2, "image_file", "mods/megumin/files/skin/enemies_gfx/player_blank.xml")
		end
	elseif ModSettingGet("megumin.SHROOM_TOGGLE") == "2" then
		if ModSettingGet("megumin.HAT_TOGGLE") == true then
			ComponentSetValue2( sprite_P, "image_file", "mods/megumin/files/skin/enemies_gfx/player_hat_m_g.xml" )
			ComponentSetValue2( sprite_PC1, "image_file", "mods/megumin/files/skin/enemies_gfx/player_hat_m_g2.xml" )
		elseif ModSettingGet("megumin.HAT_TOGGLE") == false then
			ComponentSetValue2( sprite_P, "image_file", "mods/megumin/files/skin/enemies_gfx/player_no_hat_g.xml" )
			ComponentSetValue2( sprite_PC2, "image_file", "mods/megumin/files/skin/enemies_gfx/player_no_hat_g2.xml" )
		end
	end
	SHROOMED = true
end