function OnPlayerSpawned( player_entity ) -- This runs when player entity has been created
	-- random loadout compatibility fix		
	if tonumber(StatsGetValue("playtime")) < 1 then		
		if ModSettingGet("megumin_e.MANATITE_START") ~= "0" then
			local inventory = EntityGetWithName("inventory_quick")
			if inventory ~= nil then
				local items = EntityGetAllChildren( inventory )
				if items ~= nil then
					local item = items[7]
					if EntityGetComponent(item, "ManaReloaderComponent") ~= nil then
						GameKillInventoryItem( player_entity, item )
					end
					if ModSettingGet("megumin_e.MANATITE_START") == "1" then
						EntityAddChild( inventory, EntityLoad( "data/entities/items/starting_manatite_weak.xml" ) )
						else if ModSettingGet("megumin_e.MANATITE_START") == "2" then
							EntityAddChild( inventory, EntityLoad( "data/entities/items/starting_manatite.xml" ) )
						end
					end
				end
			end
		end
		if ModSettingGet("megumin_e.EXPLOSION_ALT") == false then
			EntityAddComponent( player_entity, "LuaComponent",
			{
			  remove_after_executed="0",
			  execute_times="-1",
			  script_source_file="data/scripts/megumin_no_mana_alarm.lua"
			} )
		end
	end
end

if ModSettingGet("megumin_e.EXPLOSION_ALT") ~= true then
	ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/megumin_e/files/actions.lua" )
	else if ModSettingGet("megumin_e.EXPLOSION_ALT") == true then
		ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/megumin_e/files/actions_alt.lua" )
	end
end

ModLuaFileAppend("data/scripts/biomes/dragoncave.lua", "mods/megumin_e/files/addstaff.lua")
ModLuaFileAppend("data/scripts/biomes/magic_gate.lua", "mods/megumin_e/files/addstaff.lua")
ModLuaFileAppend("data/scripts/biomes/rainforest.lua", "mods/megumin_e/files/addstaff.lua")
ModLuaFileAppend("data/scripts/biomes/sandcave.lua", "mods/megumin_e/files/addstaff.lua")
ModLuaFileAppend("data/scripts/biomes/the_end.lua", "mods/megumin_e/files/addstaff.lua")